// Class: ReadDNN
// Automatically generated by MethodBase::MakeClass
//

/* configuration options =====================================================

#GEN -*-*-*-*-*-*-*-*-*-*-*- general info -*-*-*-*-*-*-*-*-*-*-*-

Method         : DNN::DNN
TMVA Release   : 4.2.1         [262657]
ROOT Release   : 6.20/02       [398338]
Creator        : yuanhao
Date           : Sat Oct  7 19:26:59 2023
Host           : Linux cvmfspublisher.ihep.ac.cn 3.10.0-1127.8.2.el7.x86_64 #1 SMP Tue May 12 16:57:42 UTC 2020 x86_64 x86_64 x86_64 GNU/Linux
Dir            : /scratchfs/bes/yuanhao/HardonPID/DNN/ModelTrain/Simple/C4
Training events: 19200
Analysis type  : [Classification]


#OPT -*-*-*-*-*-*-*-*-*-*-*-*- options -*-*-*-*-*-*-*-*-*-*-*-*-

# Set by User:
V: "True" [Verbose output (short form of "VerbosityLevel" below - overrides the latter one)]
VarTransform: "N" [List of variable transformations performed before training, e.g., "D_Background,P_Signal,G,N_AllClasses" for: "Decorrelation, PCA-transformation, Gaussianisation, Normalisation, each for the given class of events ('AllClasses' denotes all events of all classes, if no class indication is given, 'All' is assumed)"]
H: "False" [Print method-specific help message]
Layout: "RELU|64,RELU|256,RELU|256,RELU|128,SOFTMAX" [Layout of the network.]
ErrorStrategy: "CROSSENTROPY" [Loss function: Mean squared error (regression) or cross entropy (binary classification).]
WeightInitialization: "XAVIER" [Weight initialization strategy]
TrainingStrategy: "LearningRate=1e-1,Momentum=0.5,Repetitions=1,ConvergenceSteps=30,BatchSize=128,TestRepetitions=5,Multithreading=True|LearningRate=1e-3,Momentum=0.1,Repetitions=1,ConvergenceSteps=30,BatchSize=128,TestRepetitions=5,Multithreading=True|LearningRate=1e-5,Momentum=0.0,Repetitions=1,ConvergenceSteps=30,BatchSize=128,TestRepetitions=5,Multithreading=True" [Defines the training strategies.]
# Default:
VerbosityLevel: "Verbose" [Verbosity level]
CreateMVAPdfs: "False" [Create PDFs for classifier outputs (signal and background)]
IgnoreNegWeightsInTraining: "False" [Events with negative weights are ignored in the training (but are included for testing and performance evaluation)]
ValidationSize: "20%" [Part of the training data to use for validation. Specify as 0.2 or 20% to use a fifth of the data set as validation set. Specify as 100 to use exactly 100 events. (Default: 20%)]
Architecture: "CPU" [Which architecture to perform the training on.]
##


#VAR -*-*-*-*-*-*-*-*-*-*-*-* variables *-*-*-*-*-*-*-*-*-*-*-*-

NVar 18
mdcp                          mdcp                          mdcp                          P                                                               'F'    [0.200117573142,1.39991521835]
mdccost                       mdccost                       mdccost                       cos#theta                                                       'F'    [-0.929820299149,0.929918408394]
charge                        charge                        charge                        charge                                                          'F'    [-1,1]
chidedxpi                     chidedxpi                     chidedxpi                     #chi_{dE/dx}^{#pi}                                              'F'    [-3.59157156944,339.112701416]
chidedxk                      chidedxk                      chidedxk                      #chi_{dE/dx}^{K}                                                'F'    [-48.2383651733,162.464675903]
chidedxp                      chidedxp                      chidedxp                      #chi_{dE/dx}^{p}                                                'F'    [-18.6153411865,4.86738061905]
t11Mod                        t11Mod                        t11Mod                        tof_{11}                                                        'F'    [-34.5105361938,57.0286331177]
t12Mod                        t12Mod                        t12Mod                        tof_{12}                                                        'F'    [-22.3620700836,55.0489234924]
t21Mod                        t21Mod                        t21Mod                        tof_{21}                                                        'F'    [-30.0822582245,29.3114509583]
t22Mod                        t22Mod                        t22Mod                        tof_{22}                                                        'F'    [-20.0396595001,37.9089164734]
q0Mod                         q0Mod                         q0Mod                         q0                                                              'F'    [0,172390.203125]
energyMod/mdcp                energyMod_D_mdcp              energyMod/mdcp                E/p                                                             'F'    [0,2.21827411652]
eSeedMod/e3x3Mod              eSeedMod_D_e3x3Mod            eSeedMod/e3x3Mod              eSeed/e3x3                                                      'F'    [0,1]
emcdthetaMod                  emcdthetaMod                  emcdthetaMod                  #Delat#theta_{EMC}                                              'F'    [0,0.0364088527858]
emcnumHitsMod                 emcnumHitsMod                 emcnumHitsMod                 NHits_{EMC}                                                     'F'    [0,73]
secondMomentMod               secondMomentMod               secondMomentMod               secondMoment                                                    'F'    [0,334.756317139]
latMomentMod                  latMomentMod                  latMomentMod                  latMom                                                          'F'    [0,0.922973513603]
depthMod                      depthMod                      depthMod                      depth                                                           'F'    [-9.89999961853,178.833633423]
NSpec 0


============================================================================ */

#include <array>
#include <vector>
#include <cmath>
#include <string>
#include <iostream>

#ifndef IClassifierReader__def
#define IClassifierReader__def

class IClassifierReader {

 public:

   // constructor
   IClassifierReader() : fStatusIsClean( true ) {}
   virtual ~IClassifierReader() {}

   // return classifier response
   virtual std::vector<double> GetMulticlassValues( const std::vector<double>& inputValues ) const = 0;

   // returns classifier status
   bool IsStatusClean() const { return fStatusIsClean; }

 protected:

   bool fStatusIsClean;
};

#endif

class ReadDNN : public IClassifierReader {

 public:

   // constructor
   ReadDNN( std::vector<std::string>& theInputVars )
      : IClassifierReader(),
        fClassName( "ReadDNN" ),
        fNvars( 18 )
   {
      // the training input variables
      const char* inputVars[] = { "mdcp", "mdccost", "charge", "chidedxpi", "chidedxk", "chidedxp", "t11Mod", "t12Mod", "t21Mod", "t22Mod", "q0Mod", "energyMod/mdcp", "eSeedMod/e3x3Mod", "emcdthetaMod", "emcnumHitsMod", "secondMomentMod", "latMomentMod", "depthMod" };

      // sanity checks
      if (theInputVars.size() <= 0) {
         std::cout << "Problem in class \"" << fClassName << "\": empty input vector" << std::endl;
         fStatusIsClean = false;
      }

      if (theInputVars.size() != fNvars) {
         std::cout << "Problem in class \"" << fClassName << "\": mismatch in number of input values: "
                   << theInputVars.size() << " != " << fNvars << std::endl;
         fStatusIsClean = false;
      }

      // validate input variables
      for (size_t ivar = 0; ivar < theInputVars.size(); ivar++) {
         if (theInputVars[ivar] != inputVars[ivar]) {
            std::cout << "Problem in class \"" << fClassName << "\": mismatch in input variable names" << std::endl
                      << " for variable [" << ivar << "]: " << theInputVars[ivar].c_str() << " != " << inputVars[ivar] << std::endl;
            fStatusIsClean = false;
         }
      }

      // initialize min and max vectors (for normalisation)
      fVmin[0] = -1;
      fVmax[0] = 1;
      fVmin[1] = -1;
      fVmax[1] = 1;
      fVmin[2] = -1;
      fVmax[2] = 1;
      fVmin[3] = -1;
      fVmax[3] = 0.99999988079071;
      fVmin[4] = -1;
      fVmax[4] = 1;
      fVmin[5] = -1;
      fVmax[5] = 1;
      fVmin[6] = -1;
      fVmax[6] = 1;
      fVmin[7] = -1;
      fVmax[7] = 1;
      fVmin[8] = -1;
      fVmax[8] = 0.99999988079071;
      fVmin[9] = -1;
      fVmax[9] = 1;
      fVmin[10] = -1;
      fVmax[10] = 1;
      fVmin[11] = -1;
      fVmax[11] = 1;
      fVmin[12] = -1;
      fVmax[12] = 1;
      fVmin[13] = -1;
      fVmax[13] = 1;
      fVmin[14] = -1;
      fVmax[14] = 1;
      fVmin[15] = -1;
      fVmax[15] = 1;
      fVmin[16] = -1;
      fVmax[16] = 1;
      fVmin[17] = -1;
      fVmax[17] = 1;

      // initialize input variable types
      fType[0] = 'F';
      fType[1] = 'F';
      fType[2] = 'F';
      fType[3] = 'F';
      fType[4] = 'F';
      fType[5] = 'F';
      fType[6] = 'F';
      fType[7] = 'F';
      fType[8] = 'F';
      fType[9] = 'F';
      fType[10] = 'F';
      fType[11] = 'F';
      fType[12] = 'F';
      fType[13] = 'F';
      fType[14] = 'F';
      fType[15] = 'F';
      fType[16] = 'F';
      fType[17] = 'F';

      // initialize constants
      Initialize();

      // initialize transformation
      InitTransform();
   }

   // destructor
   virtual ~ReadDNN() {
      Clear(); // method-specific
   }

   // the classifier response
   // "inputValues" is a vector of input values in the same order as the
   // variables given to the constructor
   std::vector<double> GetMulticlassValues( const std::vector<double>& inputValues ) const override;

 private:

   // method-specific destructor
   void Clear();

   // input variable transformation

   double fOff_1[4][18];
   double fScal_1[4][18];
   void InitTransform_1();
   void Transform_1( std::vector<double> & iv, int sigOrBgd ) const;
   void InitTransform();
   void Transform( std::vector<double> & iv, int sigOrBgd ) const;

   // common member variables
   const char* fClassName;

   const size_t fNvars;
   size_t GetNvar()           const { return fNvars; }
   char   GetType( int ivar ) const { return fType[ivar]; }

   // normalisation of input variables
   double fVmin[18];
   double fVmax[18];
   double NormVariable( double x, double xmin, double xmax ) const {
      // normalise to output range: [-1, 1]
      return 2*(x - xmin)/(xmax - xmin) - 1.0;
   }

   // type of input variable: 'F' or 'I'
   char   fType[18];

   // initialize internal variables
   void Initialize();
   std::vector<double> GetMulticlassValues__( const std::vector<double>& inputValues ) const;

   // private members (method specific)
inline std::vector<double> ReadDNN::GetMulticlassValues( const std::vector<double>& inputValues ) const
{
   // classifier response value
   std::vector<double> retval;

   // classifier response, sanity check first
   if (!IsStatusClean()) {
      std::cout << "Problem in class \"" << fClassName << "\": cannot return classifier response"
                << " because status is dirty" << std::endl;
   }
   else {
         std::vector<double> iV(inputValues);
         Transform( iV, -1 );
         retval = GetMulticlassValues__( iV );
   }

   return retval;
}

//_______________________________________________________________________
inline void ReadDNN::InitTransform_1()
{
   double fMin_1[4][18];
   double fMax_1[4][18];
   // Normalization transformation, initialisation
   fMin_1[0][0] = 0.200280368328;
   fMax_1[0][0] = 1.39956867695;
   fScal_1[0][0] = 2.0/(fMax_1[0][0]-fMin_1[0][0]);
   fOff_1[0][0] = fMin_1[0][0]*fScal_1[0][0]+1.;
   fMin_1[1][0] = 0.203955635428;
   fMax_1[1][0] = 1.39991521835;
   fScal_1[1][0] = 2.0/(fMax_1[1][0]-fMin_1[1][0]);
   fOff_1[1][0] = fMin_1[1][0]*fScal_1[1][0]+1.;
   fMin_1[2][0] = 0.200117573142;
   fMax_1[2][0] = 1.11945724487;
   fScal_1[2][0] = 2.0/(fMax_1[2][0]-fMin_1[2][0]);
   fOff_1[2][0] = fMin_1[2][0]*fScal_1[2][0]+1.;
   fMin_1[3][0] = 0.200117573142;
   fMax_1[3][0] = 1.39991521835;
   fScal_1[3][0] = 2.0/(fMax_1[3][0]-fMin_1[3][0]);
   fOff_1[3][0] = fMin_1[3][0]*fScal_1[3][0]+1.;
   fMin_1[0][1] = -0.929086267948;
   fMax_1[0][1] = 0.929918408394;
   fScal_1[0][1] = 2.0/(fMax_1[0][1]-fMin_1[0][1]);
   fOff_1[0][1] = fMin_1[0][1]*fScal_1[0][1]+1.;
   fMin_1[1][1] = -0.929820299149;
   fMax_1[1][1] = 0.929913580418;
   fScal_1[1][1] = 2.0/(fMax_1[1][1]-fMin_1[1][1]);
   fOff_1[1][1] = fMin_1[1][1]*fScal_1[1][1]+1.;
   fMin_1[2][1] = -0.929574847221;
   fMax_1[2][1] = 0.92820751667;
   fScal_1[2][1] = 2.0/(fMax_1[2][1]-fMin_1[2][1]);
   fOff_1[2][1] = fMin_1[2][1]*fScal_1[2][1]+1.;
   fMin_1[3][1] = -0.929820299149;
   fMax_1[3][1] = 0.929918408394;
   fScal_1[3][1] = 2.0/(fMax_1[3][1]-fMin_1[3][1]);
   fOff_1[3][1] = fMin_1[3][1]*fScal_1[3][1]+1.;
   fMin_1[0][2] = 1;
   fMax_1[0][2] = 1;
   fScal_1[0][2] = 2.0/(fMax_1[0][2]-fMin_1[0][2]);
   fOff_1[0][2] = fMin_1[0][2]*fScal_1[0][2]+1.;
   fMin_1[1][2] = -1;
   fMax_1[1][2] = 1;
   fScal_1[1][2] = 2.0/(fMax_1[1][2]-fMin_1[1][2]);
   fOff_1[1][2] = fMin_1[1][2]*fScal_1[1][2]+1.;
   fMin_1[2][2] = 1;
   fMax_1[2][2] = 1;
   fScal_1[2][2] = 2.0/(fMax_1[2][2]-fMin_1[2][2]);
   fOff_1[2][2] = fMin_1[2][2]*fScal_1[2][2]+1.;
   fMin_1[3][2] = -1;
   fMax_1[3][2] = 1;
   fScal_1[3][2] = 2.0/(fMax_1[3][2]-fMin_1[3][2]);
   fOff_1[3][2] = fMin_1[3][2]*fScal_1[3][2]+1.;
   fMin_1[0][3] = -3.34529399872;
   fMax_1[0][3] = 6.66234445572;
   fScal_1[0][3] = 2.0/(fMax_1[0][3]-fMin_1[0][3]);
   fOff_1[0][3] = fMin_1[0][3]*fScal_1[0][3]+1.;
   fMin_1[1][3] = -3.59157156944;
   fMax_1[1][3] = 52.2244796753;
   fScal_1[1][3] = 2.0/(fMax_1[1][3]-fMin_1[1][3]);
   fOff_1[1][3] = fMin_1[1][3]*fScal_1[1][3]+1.;
   fMin_1[2][3] = -0.875830829144;
   fMax_1[2][3] = 339.112701416;
   fScal_1[2][3] = 2.0/(fMax_1[2][3]-fMin_1[2][3]);
   fOff_1[2][3] = fMin_1[2][3]*fScal_1[2][3]+1.;
   fMin_1[3][3] = -3.59157156944;
   fMax_1[3][3] = 339.112701416;
   fScal_1[3][3] = 2.0/(fMax_1[3][3]-fMin_1[3][3]);
   fOff_1[3][3] = fMin_1[3][3]*fScal_1[3][3]+1.;
   fMin_1[0][4] = -48.2383651733;
   fMax_1[0][4] = 4.70859336853;
   fScal_1[0][4] = 2.0/(fMax_1[0][4]-fMin_1[0][4]);
   fOff_1[0][4] = fMin_1[0][4]*fScal_1[0][4]+1.;
   fMin_1[1][4] = -6.1140537262;
   fMax_1[1][4] = 5.77946519852;
   fScal_1[1][4] = 2.0/(fMax_1[1][4]-fMin_1[1][4]);
   fOff_1[1][4] = fMin_1[1][4]*fScal_1[1][4]+1.;
   fMin_1[2][4] = -7.25450897217;
   fMax_1[2][4] = 162.464675903;
   fScal_1[2][4] = 2.0/(fMax_1[2][4]-fMin_1[2][4]);
   fOff_1[2][4] = fMin_1[2][4]*fScal_1[2][4]+1.;
   fMin_1[3][4] = -48.2383651733;
   fMax_1[3][4] = 162.464675903;
   fScal_1[3][4] = 2.0/(fMax_1[3][4]-fMin_1[3][4]);
   fOff_1[3][4] = fMin_1[3][4]*fScal_1[3][4]+1.;
   fMin_1[0][5] = -18.6153411865;
   fMax_1[0][5] = 0.760703384876;
   fScal_1[0][5] = 2.0/(fMax_1[0][5]-fMin_1[0][5]);
   fOff_1[0][5] = fMin_1[0][5]*fScal_1[0][5]+1.;
   fMin_1[1][5] = -13.47290802;
   fMax_1[1][5] = 0.380704522133;
   fScal_1[1][5] = 2.0/(fMax_1[1][5]-fMin_1[1][5]);
   fOff_1[1][5] = fMin_1[1][5]*fScal_1[1][5]+1.;
   fMin_1[2][5] = -13.0587434769;
   fMax_1[2][5] = 4.86738061905;
   fScal_1[2][5] = 2.0/(fMax_1[2][5]-fMin_1[2][5]);
   fOff_1[2][5] = fMin_1[2][5]*fScal_1[2][5]+1.;
   fMin_1[3][5] = -18.6153411865;
   fMax_1[3][5] = 4.86738061905;
   fScal_1[3][5] = 2.0/(fMax_1[3][5]-fMin_1[3][5]);
   fOff_1[3][5] = fMin_1[3][5]*fScal_1[3][5]+1.;
   fMin_1[0][6] = -34.5105361938;
   fMax_1[0][6] = 19.1289310455;
   fScal_1[0][6] = 2.0/(fMax_1[0][6]-fMin_1[0][6]);
   fOff_1[0][6] = fMin_1[0][6]*fScal_1[0][6]+1.;
   fMin_1[1][6] = -19.0875644684;
   fMax_1[1][6] = 57.0286331177;
   fScal_1[1][6] = 2.0/(fMax_1[1][6]-fMin_1[1][6]);
   fOff_1[1][6] = fMin_1[1][6]*fScal_1[1][6]+1.;
   fMin_1[2][6] = -20.1496086121;
   fMax_1[2][6] = 12.0929756165;
   fScal_1[2][6] = 2.0/(fMax_1[2][6]-fMin_1[2][6]);
   fOff_1[2][6] = fMin_1[2][6]*fScal_1[2][6]+1.;
   fMin_1[3][6] = -34.5105361938;
   fMax_1[3][6] = 57.0286331177;
   fScal_1[3][6] = 2.0/(fMax_1[3][6]-fMin_1[3][6]);
   fOff_1[3][6] = fMin_1[3][6]*fScal_1[3][6]+1.;
   fMin_1[0][7] = -22.3620700836;
   fMax_1[0][7] = 19.1428966522;
   fScal_1[0][7] = 2.0/(fMax_1[0][7]-fMin_1[0][7]);
   fOff_1[0][7] = fMin_1[0][7]*fScal_1[0][7]+1.;
   fMin_1[1][7] = -19.1053886414;
   fMax_1[1][7] = 55.0489234924;
   fScal_1[1][7] = 2.0/(fMax_1[1][7]-fMin_1[1][7]);
   fOff_1[1][7] = fMin_1[1][7]*fScal_1[1][7]+1.;
   fMin_1[2][7] = -20.1680717468;
   fMax_1[2][7] = 16.8745613098;
   fScal_1[2][7] = 2.0/(fMax_1[2][7]-fMin_1[2][7]);
   fOff_1[2][7] = fMin_1[2][7]*fScal_1[2][7]+1.;
   fMin_1[3][7] = -22.3620700836;
   fMax_1[3][7] = 55.0489234924;
   fScal_1[3][7] = 2.0/(fMax_1[3][7]-fMin_1[3][7]);
   fOff_1[3][7] = fMin_1[3][7]*fScal_1[3][7]+1.;
   fMin_1[0][8] = -30.0822582245;
   fMax_1[0][8] = 19.2497158051;
   fScal_1[0][8] = 2.0/(fMax_1[0][8]-fMin_1[0][8]);
   fOff_1[0][8] = fMin_1[0][8]*fScal_1[0][8]+1.;
   fMin_1[1][8] = -19.2162437439;
   fMax_1[1][8] = 16.3429374695;
   fScal_1[1][8] = 2.0/(fMax_1[1][8]-fMin_1[1][8]);
   fOff_1[1][8] = fMin_1[1][8]*fScal_1[1][8]+1.;
   fMin_1[2][8] = -19.7407798767;
   fMax_1[2][8] = 29.3114509583;
   fScal_1[2][8] = 2.0/(fMax_1[2][8]-fMin_1[2][8]);
   fOff_1[2][8] = fMin_1[2][8]*fScal_1[2][8]+1.;
   fMin_1[3][8] = -30.0822582245;
   fMax_1[3][8] = 29.3114509583;
   fScal_1[3][8] = 2.0/(fMax_1[3][8]-fMin_1[3][8]);
   fOff_1[3][8] = fMin_1[3][8]*fScal_1[3][8]+1.;
   fMin_1[0][9] = -19.6198406219;
   fMax_1[0][9] = 19.3131942749;
   fScal_1[0][9] = 2.0/(fMax_1[0][9]-fMin_1[0][9]);
   fOff_1[0][9] = fMin_1[0][9]*fScal_1[0][9]+1.;
   fMin_1[1][9] = -18.4563655853;
   fMax_1[1][9] = 13.2498960495;
   fScal_1[1][9] = 2.0/(fMax_1[1][9]-fMin_1[1][9]);
   fOff_1[1][9] = fMin_1[1][9]*fScal_1[1][9]+1.;
   fMin_1[2][9] = -20.0396595001;
   fMax_1[2][9] = 37.9089164734;
   fScal_1[2][9] = 2.0/(fMax_1[2][9]-fMin_1[2][9]);
   fOff_1[2][9] = fMin_1[2][9]*fScal_1[2][9]+1.;
   fMin_1[3][9] = -20.0396595001;
   fMax_1[3][9] = 37.9089164734;
   fScal_1[3][9] = 2.0/(fMax_1[3][9]-fMin_1[3][9]);
   fOff_1[3][9] = fMin_1[3][9]*fScal_1[3][9]+1.;
   fMin_1[0][10] = 0;
   fMax_1[0][10] = 161701.5;
   fScal_1[0][10] = 2.0/(fMax_1[0][10]-fMin_1[0][10]);
   fOff_1[0][10] = fMin_1[0][10]*fScal_1[0][10]+1.;
   fMin_1[1][10] = 0;
   fMax_1[1][10] = 168139.828125;
   fScal_1[1][10] = 2.0/(fMax_1[1][10]-fMin_1[1][10]);
   fOff_1[1][10] = fMin_1[1][10]*fScal_1[1][10]+1.;
   fMin_1[2][10] = 0;
   fMax_1[2][10] = 172390.203125;
   fScal_1[2][10] = 2.0/(fMax_1[2][10]-fMin_1[2][10]);
   fOff_1[2][10] = fMin_1[2][10]*fScal_1[2][10]+1.;
   fMin_1[3][10] = 0;
   fMax_1[3][10] = 172390.203125;
   fScal_1[3][10] = 2.0/(fMax_1[3][10]-fMin_1[3][10]);
   fOff_1[3][10] = fMin_1[3][10]*fScal_1[3][10]+1.;
   fMin_1[0][11] = 0;
   fMax_1[0][11] = 1.12596821785;
   fScal_1[0][11] = 2.0/(fMax_1[0][11]-fMin_1[0][11]);
   fOff_1[0][11] = fMin_1[0][11]*fScal_1[0][11]+1.;
   fMin_1[1][11] = 0;
   fMax_1[1][11] = 2.21827411652;
   fScal_1[1][11] = 2.0/(fMax_1[1][11]-fMin_1[1][11]);
   fOff_1[1][11] = fMin_1[1][11]*fScal_1[1][11]+1.;
   fMin_1[2][11] = 0;
   fMax_1[2][11] = 0.994087159634;
   fScal_1[2][11] = 2.0/(fMax_1[2][11]-fMin_1[2][11]);
   fOff_1[2][11] = fMin_1[2][11]*fScal_1[2][11]+1.;
   fMin_1[3][11] = 0;
   fMax_1[3][11] = 2.21827411652;
   fScal_1[3][11] = 2.0/(fMax_1[3][11]-fMin_1[3][11]);
   fOff_1[3][11] = fMin_1[3][11]*fScal_1[3][11]+1.;
   fMin_1[0][12] = 0;
   fMax_1[0][12] = 1;
   fScal_1[0][12] = 2.0/(fMax_1[0][12]-fMin_1[0][12]);
   fOff_1[0][12] = fMin_1[0][12]*fScal_1[0][12]+1.;
   fMin_1[1][12] = 0;
   fMax_1[1][12] = 1;
   fScal_1[1][12] = 2.0/(fMax_1[1][12]-fMin_1[1][12]);
   fOff_1[1][12] = fMin_1[1][12]*fScal_1[1][12]+1.;
   fMin_1[2][12] = 0;
   fMax_1[2][12] = 1;
   fScal_1[2][12] = 2.0/(fMax_1[2][12]-fMin_1[2][12]);
   fOff_1[2][12] = fMin_1[2][12]*fScal_1[2][12]+1.;
   fMin_1[3][12] = 0;
   fMax_1[3][12] = 1;
   fScal_1[3][12] = 2.0/(fMax_1[3][12]-fMin_1[3][12]);
   fOff_1[3][12] = fMin_1[3][12]*fScal_1[3][12]+1.;
   fMin_1[0][13] = 0;
   fMax_1[0][13] = 0.0364088527858;
   fScal_1[0][13] = 2.0/(fMax_1[0][13]-fMin_1[0][13]);
   fOff_1[0][13] = fMin_1[0][13]*fScal_1[0][13]+1.;
   fMin_1[1][13] = 0;
   fMax_1[1][13] = 0.0360257588327;
   fScal_1[1][13] = 2.0/(fMax_1[1][13]-fMin_1[1][13]);
   fOff_1[1][13] = fMin_1[1][13]*fScal_1[1][13]+1.;
   fMin_1[2][13] = 0;
   fMax_1[2][13] = 0.0344357788563;
   fScal_1[2][13] = 2.0/(fMax_1[2][13]-fMin_1[2][13]);
   fOff_1[2][13] = fMin_1[2][13]*fScal_1[2][13]+1.;
   fMin_1[3][13] = 0;
   fMax_1[3][13] = 0.0364088527858;
   fScal_1[3][13] = 2.0/(fMax_1[3][13]-fMin_1[3][13]);
   fOff_1[3][13] = fMin_1[3][13]*fScal_1[3][13]+1.;
   fMin_1[0][14] = 0;
   fMax_1[0][14] = 73;
   fScal_1[0][14] = 2.0/(fMax_1[0][14]-fMin_1[0][14]);
   fOff_1[0][14] = fMin_1[0][14]*fScal_1[0][14]+1.;
   fMin_1[1][14] = 0;
   fMax_1[1][14] = 73;
   fScal_1[1][14] = 2.0/(fMax_1[1][14]-fMin_1[1][14]);
   fOff_1[1][14] = fMin_1[1][14]*fScal_1[1][14]+1.;
   fMin_1[2][14] = 0;
   fMax_1[2][14] = 38;
   fScal_1[2][14] = 2.0/(fMax_1[2][14]-fMin_1[2][14]);
   fOff_1[2][14] = fMin_1[2][14]*fScal_1[2][14]+1.;
   fMin_1[3][14] = 0;
   fMax_1[3][14] = 73;
   fScal_1[3][14] = 2.0/(fMax_1[3][14]-fMin_1[3][14]);
   fOff_1[3][14] = fMin_1[3][14]*fScal_1[3][14]+1.;
   fMin_1[0][15] = 0;
   fMax_1[0][15] = 334.756317139;
   fScal_1[0][15] = 2.0/(fMax_1[0][15]-fMin_1[0][15]);
   fOff_1[0][15] = fMin_1[0][15]*fScal_1[0][15]+1.;
   fMin_1[1][15] = 0;
   fMax_1[1][15] = 245.87739563;
   fScal_1[1][15] = 2.0/(fMax_1[1][15]-fMin_1[1][15]);
   fOff_1[1][15] = fMin_1[1][15]*fScal_1[1][15]+1.;
   fMin_1[2][15] = 0;
   fMax_1[2][15] = 180.174667358;
   fScal_1[2][15] = 2.0/(fMax_1[2][15]-fMin_1[2][15]);
   fOff_1[2][15] = fMin_1[2][15]*fScal_1[2][15]+1.;
   fMin_1[3][15] = 0;
   fMax_1[3][15] = 334.756317139;
   fScal_1[3][15] = 2.0/(fMax_1[3][15]-fMin_1[3][15]);
   fOff_1[3][15] = fMin_1[3][15]*fScal_1[3][15]+1.;
   fMin_1[0][16] = 0;
   fMax_1[0][16] = 0.903105020523;
   fScal_1[0][16] = 2.0/(fMax_1[0][16]-fMin_1[0][16]);
   fOff_1[0][16] = fMin_1[0][16]*fScal_1[0][16]+1.;
   fMin_1[1][16] = 0;
   fMax_1[1][16] = 0.922973513603;
   fScal_1[1][16] = 2.0/(fMax_1[1][16]-fMin_1[1][16]);
   fOff_1[1][16] = fMin_1[1][16]*fScal_1[1][16]+1.;
   fMin_1[2][16] = 0;
   fMax_1[2][16] = 0.900932013988;
   fScal_1[2][16] = 2.0/(fMax_1[2][16]-fMin_1[2][16]);
   fOff_1[2][16] = fMin_1[2][16]*fScal_1[2][16]+1.;
   fMin_1[3][16] = 0;
   fMax_1[3][16] = 0.922973513603;
   fScal_1[3][16] = 2.0/(fMax_1[3][16]-fMin_1[3][16]);
   fOff_1[3][16] = fMin_1[3][16]*fScal_1[3][16]+1.;
   fMin_1[0][17] = -9.89999961853;
   fMax_1[0][17] = 166.548202515;
   fScal_1[0][17] = 2.0/(fMax_1[0][17]-fMin_1[0][17]);
   fOff_1[0][17] = fMin_1[0][17]*fScal_1[0][17]+1.;
   fMin_1[1][17] = -9.89999961853;
   fMax_1[1][17] = 178.833633423;
   fScal_1[1][17] = 2.0/(fMax_1[1][17]-fMin_1[1][17]);
   fOff_1[1][17] = fMin_1[1][17]*fScal_1[1][17]+1.;
   fMin_1[2][17] = -9.89999961853;
   fMax_1[2][17] = 55.6135787964;
   fScal_1[2][17] = 2.0/(fMax_1[2][17]-fMin_1[2][17]);
   fOff_1[2][17] = fMin_1[2][17]*fScal_1[2][17]+1.;
   fMin_1[3][17] = -9.89999961853;
   fMax_1[3][17] = 178.833633423;
   fScal_1[3][17] = 2.0/(fMax_1[3][17]-fMin_1[3][17]);
   fOff_1[3][17] = fMin_1[3][17]*fScal_1[3][17]+1.;
}

//_______________________________________________________________________
inline void ReadDNN::Transform_1( std::vector<double>& iv, int cls) const
{
   // Normalization transformation
   if (cls < 0 || cls > 3) {
   if (3 > 1 ) cls = 3;
      else cls = 2;
   }
   const int nVar = 18;

   // get indices of used variables

   // define the indices of the variables which are transformed by this transformation
   static std::vector<int> indicesGet;
   static std::vector<int> indicesPut;

   if ( indicesGet.empty() ) {
      indicesGet.reserve(fNvars);
      indicesGet.push_back( 0);
      indicesGet.push_back( 1);
      indicesGet.push_back( 2);
      indicesGet.push_back( 3);
      indicesGet.push_back( 4);
      indicesGet.push_back( 5);
      indicesGet.push_back( 6);
      indicesGet.push_back( 7);
      indicesGet.push_back( 8);
      indicesGet.push_back( 9);
      indicesGet.push_back( 10);
      indicesGet.push_back( 11);
      indicesGet.push_back( 12);
      indicesGet.push_back( 13);
      indicesGet.push_back( 14);
      indicesGet.push_back( 15);
      indicesGet.push_back( 16);
      indicesGet.push_back( 17);
   }
   if ( indicesPut.empty() ) {
      indicesPut.reserve(fNvars);
      indicesPut.push_back( 0);
      indicesPut.push_back( 1);
      indicesPut.push_back( 2);
      indicesPut.push_back( 3);
      indicesPut.push_back( 4);
      indicesPut.push_back( 5);
      indicesPut.push_back( 6);
      indicesPut.push_back( 7);
      indicesPut.push_back( 8);
      indicesPut.push_back( 9);
      indicesPut.push_back( 10);
      indicesPut.push_back( 11);
      indicesPut.push_back( 12);
      indicesPut.push_back( 13);
      indicesPut.push_back( 14);
      indicesPut.push_back( 15);
      indicesPut.push_back( 16);
      indicesPut.push_back( 17);
   }

   static std::vector<double> dv;
   dv.resize(nVar);
   for (int ivar=0; ivar<nVar; ivar++) dv[ivar] = iv[indicesGet.at(ivar)];
   for (int ivar=0;ivar<18;ivar++) {
      double offset = fOff_1[cls][ivar];
      double scale  = fScal_1[cls][ivar];
      iv[indicesPut.at(ivar)] = scale*dv[ivar]-offset;
   }
}

//_______________________________________________________________________
inline void ReadDNN::InitTransform()
{
   InitTransform_1();
}

//_______________________________________________________________________
inline void ReadDNN::Transform( std::vector<double>& iv, int sigOrBgd ) const
{
   Transform_1( iv, sigOrBgd );
}
